#define  IRREADER  8
//#define IROUT 13
#define BUZZER 12
#define LED 7

#define MODE_WAIT 0
#define MODE_READ 1
#define STARTCOMMAND 's'
#define ENDCOMMAND 'e'
#define OKMESSAGE 'o'
#define QUITMESSAGE  'q'

unsigned int data[512] = {};

int last = 0;
unsigned long us = micros();
int mode = MODE_WAIT;
boolean readStart = false;

// セットアップ
void setup() {
  Serial.begin(115200);        // シリアル通信速度の設定
  pinMode(IRREADER, INPUT);  // 入出力ピンの設定
  pinMode(BUZZER, OUTPUT);
  pinMode(LED, OUTPUT);
}



void loop() {
  updateMode();
  readIRData();
  showLED();  
}
void  updateMode()
{
  if(Serial.available()>0)
  {
    int v = Serial.read();
    if(mode == MODE_WAIT)
    {
      if(v == STARTCOMMAND)
      {
        mode = MODE_READ;
        us = micros();
        readStart = false;
        Serial.write(OKMESSAGE);
      }
      else if(v == ENDCOMMAND)
      {
        mode = MODE_WAIT;
        us = micros();
        readStart = false;
        Serial.write(QUITMESSAGE);
      }
    }
    else if(mode == MODE_READ)
    {
      if(v == ENDCOMMAND)
      {
        mode = MODE_WAIT;
        us = micros();
        readStart = false;
        Serial.write(QUITMESSAGE);
      }
    }
  }
}
int getIRRearderValue(int v)
{
  if(v == HIGH)
  {
    return 0;
  }
  else
  {
    return 1;
  }
}

void readIRData()
{
  int val = 0;
  int cnt = 0;
  unsigned long us2 = 0;
  if(mode == MODE_READ)
  {
    us2 = micros();
    val = getIRRearderValue(digitalRead(IRREADER));
    if(val != last)
    {
      us2 = micros();
      Serial.print(last, DEC);
      Serial.write("-");   
      Serial.print((us2-us), DEC);   // 赤外線のON/OFFが続いた時間を1us単位で送信
      Serial.write(" ");
      last = val;
      us = us2;
      readStart = true;
    }
    else
    {
      us2 = micros();
      if(readStart == true)
      {
         if(us2 - us > 100000) //100msで抜ける。
         {
            Serial.print(last, DEC);
            Serial.write("-");   
            Serial.print((us2-us), DEC);   // 赤外線のON/OFFが続いた時間を1us単位で送信
            Serial.write("e\n");
            mode = MODE_WAIT;
            us = us2;
            readStart = false;
            last = 0;
            digitalWrite(BUZZER, HIGH);
            delay(100);
            digitalWrite(BUZZER, LOW);
          }
      }
      else
      {
        if(us2 - us > 30000000) //30sで抜ける。
        {
          Serial.print(last, DEC);
          Serial.write("-");   
          Serial.print((us2-us), DEC);   // 赤外線のON/OFFが続いた時間を1us単位で送信
          Serial.write("e\n");
          mode = MODE_WAIT;
          us = us2;
          readStart = false;
          last = 0;
          
        }
      }
    }
  }
}
void showLED()
{
    if(mode == MODE_READ)
    {
      digitalWrite(LED, HIGH);
    }
    else
    {
      digitalWrite(LED, LOW);
    }
}
